#include <bblean\bbapi.h>
#include <vector>

enum {BBLEAN,BB4WIN,XOBLITE};
int branch=0;

char rcpath[MAX_PATH];
std::vector<char *> windowClassList,exclusionList;
HINSTANCE hInstance;
static HANDLE   hProcess = NULL;
static HWND     hPluginWnd = NULL;
static int      bb_messages[] = {BB_TASKSUPDATE, 0};
void ReadRCSettings(void);
bool useClass;

LPCSTR pluginInfo(int x)
{
	switch (x)
	{
		case PLUGIN_NAME:			return "OpenFocus";
		case PLUGIN_VERSION:		return "0.0.2";
		case PLUGIN_AUTHOR:			return "Carsomyr";
		case PLUGIN_RELEASEDATE:	return "2006/03/13";
		case PLUGIN_LINK:			return "None";
		case PLUGIN_EMAIL:			return "s23120712@tuks.co.za";
		default:					return "OpenFocus 0.0.2";
	}
}

LRESULT CALLBACK PluginProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch(message)
	{
	case BB_TASKSUPDATE:
		switch(lParam)
		{
		case TASKITEM_ADDED:
		{
			//Sleep(100);
			char part1[512],part2[512];
			char windowInfo[1025];
			GetClassName((HWND)wParam, part1, 511);
			for(std::vector<char *>::iterator i=windowClassList.begin();i!=windowClassList.end();++i)
			{
				char *windowClass = *i;
				bool excluded=false;
				for(std::vector<char *>::iterator j=exclusionList.begin();j!=exclusionList.end();++j)
					if (!strcmp(part1,*j))
					{
						excluded=true;
						break;
					}
				if ((!strcmp(part1,windowClass)||(!useClass))&&(!excluded))
				{
					SendMessage((HWND)wParam,WM_GETTEXT,(WPARAM)511,(LPARAM)part2);
					if (useClass) strcpy(windowInfo,part1);
					strcat(windowInfo,":");
					strcat(windowInfo,part2);
					for(int i=0;i<GetTaskListSize();++i)
					{
						HWND temp=GetTask(i);
						if (temp!=(HWND)wParam)
						{
							GetClassName(temp, part1, 511);
							bool excluded2=false;
							for(std::vector<char *>::iterator j=exclusionList.begin();j!=exclusionList.end();++j)
								if (!strcmp(part1,*j))
								{
									excluded2=true;
									break;
								}
							if ((!strcmp(part1,windowClass)||(!useClass))&&!excluded2)
							{
								SendMessage(temp,WM_GETTEXT,(WPARAM)511,(LPARAM)part2);
								char windowInfo2[1025];
								if (useClass) strcpy(windowInfo2,part1);
								strcat(windowInfo2,":");
								strcat(windowInfo2,part2);
								if ((!strcmp(windowInfo,windowInfo2))&&!(0x8000 & GetAsyncKeyState(VK_MENU)))
								{
									PostMessage((HWND)wParam,WM_CLOSE,0,0);
									Sleep(100);
									SetForegroundWindow(temp);
									break;
								}
							}
						}
					}
				}
				if (!useClass) break;
			}
			break;
		}
		}
		return 0;
	default:
		return DefWindowProc(hwnd, message, wParam, lParam);
	}
	return 0;
}

int beginPluginEx(HINSTANCE h_instance, HWND hSlit)
{
    return beginPlugin(h_instance);
}

int beginSlitPlugin(HINSTANCE h_instance, HWND hSlit)
{
    return beginPlugin(h_instance);
}

int beginPlugin(HINSTANCE h_instance)
{
    hInstance=h_instance;
	if (!strnicmp(GetBBVersion(),"bblean",6))
        branch=BBLEAN;
    else if (!strnicmp(GetBBVersion(),"0.",2))
        branch=BB4WIN;
    else
        branch=XOBLITE;
    ReadRCSettings();
    WNDCLASS wc;
    ZeroMemory(&wc, sizeof(wc));
    wc.lpfnWndProc = PluginProc;
    wc.hInstance = h_instance;
    wc.lpszClassName = pluginInfo(PLUGIN_NAME);
    RegisterClass(&wc);

    hPluginWnd = CreateWindowEx(
        WS_EX_TOOLWINDOW,
        pluginInfo(PLUGIN_NAME),
        NULL,
        WS_POPUP|WS_ICONIC,
        -4, -4, 0, 0,
        HWND_MESSAGE,
        NULL,
        h_instance,
        NULL
    );
    hProcess = GetCurrentProcess();
    SendMessage(GetBBWnd(), BB_REGISTERMESSAGE, (WPARAM)hPluginWnd, (LPARAM)bb_messages);
    return 0;
}

//---------------------------------------------------------------------------------

void endPlugin(HINSTANCE h_instance)
{
    DestroyWindow(hPluginWnd);
    SendMessage(GetBBWnd(), BB_UNREGISTERMESSAGE, (WPARAM)hPluginWnd, (LPARAM)bb_messages);
    UnregisterClass(pluginInfo(PLUGIN_NAME), h_instance);
}

//---------------------------------------------------------------------------------
void ReadRCSettings(void)
{
    char name[MAX_PATH];
	int i = 0;
	do
	{
		// First and third, we look for the config file
		// in the same folder as the plugin...
		HINSTANCE hInst = hInstance;
		//Allow us to get the name of dll used
		GetModuleFileName(hInst, rcpath, sizeof(rcpath));
		char *plugin_name = strrchr(rcpath, '\\');
		plugin_name++;
		char *extension_start = strrchr(plugin_name, '.');
		extension_start++;
		extension_start[0]='r';
        extension_start[1]='c';
        extension_start[2]=0;
        strcpy(name,plugin_name);
		// second we check the blackbox directory
		if (1 == i) hInst = NULL;

		GetModuleFileName(hInst, rcpath, sizeof(rcpath));
		char *file_name_start = strrchr(rcpath, '\\');
                
		if (file_name_start) ++file_name_start;
		else file_name_start = strchr(rcpath, 0);
		strcpy(file_name_start, name);
	} 
	while (++i < 3 && false == FileExists(rcpath));
	useClass=ReadBool(rcpath,"OpenFocus.useClass:",true);
	long int readIndex = 0;
    const char *data = NULL;
    do
    {
        data = ReadValue(rcpath,"OpenFocus.windowclass:",&readIndex);
        if (branch==XOBLITE) ++readIndex;
        if (data)
        {
            char *windClass=new char[strlen(data)+1];
			strcpy(windClass,data);
			windowClassList.push_back(windClass);
        }
    }
    while(data);
	readIndex=0;
	data=NULL;
	do
    {
        data = ReadValue(rcpath,"OpenFocus.exclude:",&readIndex);
        if (branch==XOBLITE) ++readIndex;
        if (data)
        {
            char *windClass=new char[strlen(data)+1];
			strcpy(windClass,data);
			exclusionList.push_back(windClass);
        }
    }
    while(data);
	// If a config file was found we read the plugin settings from it...
	// ...if not, the ReadXXX functions give us just the defaults.
    
}
